//-----------------------------------------------------------------------------
// Environmentmapping + Reflection by Andreas Gustafsson (Shadow/Noice) (C)1999
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Texture.h"
#pragma warning(disable : 4305)

//----------------------------------------
// Usefull debugger thingy.
void DebugOut(const char *szFormat, ...);
//----------------------------------------

// Change your App Name.
char szAppName[] = "Environmentmapping + Reflection by Andreas Gustafsson (Shadow/Noice) (C)1999";

// Timer info.  Very useful for keeping animated stuff in sync on different computers.
extern float fTime, fDeltaTime;

// Current window dimensions.
extern GLsizei g_w, g_h;

float v1=0.0f,v2=0.0f,v3=0.0f,v4=135.0f;

// Use the demonstration texture.
CTexture gTexExample;
CTexture gTexExample2;
CTexture gTexExample3;

// Startup Stuff.
bool Init()	// Called right after the window is created, and OpenGL is initialized.
{

	glViewport (0, 0, (GLsizei) g_w, (GLsizei) g_h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(55.0, (GLfloat) g_w/(GLfloat) g_h, 1.0, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef (0.0, 0.0, -4.0);

	glEnable(GL_DEPTH_TEST);
 	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	gTexExample.LoadJPG( "o021.jpg" );
	gTexExample2.LoadJPG( "envmap.jpg" );
	gTexExample3.LoadJPG( "marbteal.jpg" );
	glEnable( GL_TEXTURE_2D );
	glEnable(GL_NORMALIZE);



	// If everything went well, then return true.
	// Returning false will cause the program to quit right away.
	return true;
}

void Shutdown() // Called right after the window is destroyed.
{
}

#include "3dobj.c" 

// Draw all the scene related stuff.
void Render()
{
	float size=0.85f;

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();

	glTranslatef(0,-0.5,0);
	glRotatef((float)(35.0+25.0*sin(v4*PI/180)), 1.0f, 0.0f, 0.0f); 
	glRotatef(fTime*10, 0.0, 1.0f, 0.0f); 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	
	v1+=30.0f*fDeltaTime;
	if(v1>360.0f) v1=v1-360.0f;
	v2+=15.0f*fDeltaTime;
	if(v2>360.0f) v2=v2-360.0f;
	v3+=20.0f*fDeltaTime;
	if(v3>360.0f) v3=v3-360.0f;
	v4+=10.0f*fDeltaTime;
	if(v4>360.0f) v4=v4-360.0f;


	glPushMatrix();
	glTranslatef(0,1.4,0);
	glScalef(size,size,size);	
	glRotatef( v1, 1.0f, 0, 0);
	glRotatef( v2, 0, 1.0f, 0 );
	glRotatef( v3, 0, 0, 1.0f );
	gTexExample.Use(); // Tells OpenGL to use this texture.
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glTexGenf(GL_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	glTexGenf(GL_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	glDepthFunc(GL_LESS);
	glDisable(GL_BLEND);
	glColor3f(0.5,0.5,0.5);
	glFrontFace(GL_CCW);
	draw3DObj();
	glTexGenf(GL_S,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
	glTexGenf(GL_T,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_BLEND);
	gTexExample2.Use(); // Tells OpenGL to use this texture.
	glColor3f(1.0,1.0,1.0);
	draw3DObj();
	
	glPopMatrix();
	glPushMatrix();
	glTranslatef(0,-1.4,0);
	glScalef(size,-size,size);	
	
	glRotatef( v1, 1.0f, 0, 0);
	glRotatef( v2, 0, 1.0f, 0 );
	glRotatef( v3, 0, 0, 1.0f );
	gTexExample.Use(); // Tells OpenGL to use this texture.
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glTexGenf(GL_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	glTexGenf(GL_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	glDepthFunc(GL_LESS);
	glDisable(GL_BLEND);
	glColor3f(0.5,0.5,0.5);
	glFrontFace(GL_CW);
	draw3DObj();
	glTexGenf(GL_S,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
	glTexGenf(GL_T,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_BLEND);
	gTexExample2.Use(); // Tells OpenGL to use this texture.
	glColor3f(1.0,1.0,1.0);
	draw3DObj();
	glPopMatrix();

	glEnable(GL_BLEND);
	//glDisable( GL_TEXTURE_2D );
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthFunc(GL_LESS);
	gTexExample3.Use(); 
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glBegin(GL_QUADS);
	glColor4f(1.0f,1.0f,1.0f,0.5f); 
	glTexCoord2f( 0, 0 );
	glVertex3f(-2.75f,0.0f,-2.75f);
	glTexCoord2f( 1, 0 );
	glVertex3f(2.75f,0.0f,-2.75f);
	glTexCoord2f( 1, 1);
	glVertex3f(2.75f,0.0f,2.75f);
	glTexCoord2f( 0, 1 );
	glVertex3f(-2.75f,0.0f,2.75f);
	glEnd();


	glPopMatrix();
}
